local L = LibStub("AceLocale-3.0"):GetLocale("sRaidFrames")
local Media = LibStub("LibSharedMedia-3.0")
local sRaidFrames = sRaidFrames

sRaidFrames.Layouts = {}

function sRaidFrames:RegisterLayout(name, data)
	self.Layouts[name] = data
	
	self.options.args.behaviour.args.layout.values = {}
	for _name, _data in pairs(self.Layouts) do
		self.options.args.behaviour.args.layout.values[_name] = _data.Name
	end
end

function sRaidFrames:CreateLayout(name)
	local i = #sRaidFrames.opt.Layouts+1;
	sRaidFrames.opt.Layouts[i] = {
		border = false,
		name = name,
		intname = string.gsub(string.lower(name), " ", ""),
		debuff = {
			width = 16,
			height = 16,
			anchor = "TOPRIGHT",
		},
		buff = {
			width = 12,
			height = 12,
		},
		title = {
			width = 80,
			height = 16,
			offsetx = 0,
			offsety = 0,
		},
		mpbar = {
			height = 4,
		},
		hpbar = {
			height = 12,
		},
	}
	local data = sRaidFrames.opt.Layouts[i];
	sRaidFrames:RegisterLayout(data.intname, {
		Name = data.name,
		HasBorders = data.border,
		StyleUnitFrame = function(f)
			sRaidFrames:SetWHP(f, data.border and data.title.width+10 or data.title.width, (data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height));
			sRaidFrames:SetWHP(f.title, data.title.width, data.title.height, "TOPLEFT", f, "TOPLEFT", data.border and data.title.offsetx+5 or data.title.offsetx, data.border and data.title.offsety-4 or data.title.offsety)
			sRaidFrames:SetWHP(f.aura1, data.debuff.width, data.debuff.height, data.debuff.anchor, f, data.debuff.anchor, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)
			sRaidFrames:SetWHP(f.aura2, data.debuff.width, data.debuff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.aura1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			if sRaidFrames.opt.BuffType == "both" then
				sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor=="TOPRIGHT" and "TOPLEFT" or data.debuff.anchor=="TOPLEFT" and "TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT" and "BOTTOMLEFT" or data.debuff.anchor=="BOTTOMLEFT" and "BOTTOMRIGHT", 0, 0)
			else
				sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)
			end
			sRaidFrames:SetWHP(f.buff2, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.buff3, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff2, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.buff4, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff3, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.hpbar, data.title.width, data.hpbar.height, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
			sRaidFrames:SetWHP(f.mpbar, data.title.width, data.mpbar.height, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
			sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
			sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
			f:SetBackdrop(data.border and { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
									tile = true,
									tileSize = 16,
									edgeFile = Media:Fetch("border", sRaidFrames.opt.BorderTexture),
									edgeSize = 16,
									insets = { left = 5, right = 5, top = 5, bottom = 5 }
								} or { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
			f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
			f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		end,
		unitframeWidth = data.border and data.title.width+10 or data.title.width,
		unitframeHeight = (data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height),
		headerWidth = data.border and data.title.width+10 or data.title.width,
		headerHeight = 15, -- needs more testing
		debuffCount = 2,
		buffCount = 4,
	})
	self.options.args.layouts.args[data.intname] = {
		name = data.name,
		type = "group",
		desc = L["Configure "]..data.name,
		args = {
			titlebar = {
				name = L["Title bar"],
				type = "group",
				desc = string.format(L["Configure this layout's %s bar"], L["title"]),
				args = {
					height = {
						name = L["Height"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["title"]),
						get = function() return self.opt.Layouts[i].title.height or 16 end,
						set = function(info, value) self.opt.Layouts[i].title.height = tonumber(value); self:LayoutUpdate(i); end,
					},
					width = {
						name = L["Width"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["width"], L["title"]),
						get = function() return self.opt.Layouts[i].title.width or 80 end,
						set = function(info, value) self.opt.Layouts[i].title.width = tonumber(value); self:LayoutUpdate(i); end,
					},
					offsets = {
						name = L["Offsets"],
						type = "group",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["offsets"], L["title"]),
						args = {
							x = {
								name = "X",
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s bar"], "X "..L["offset"], L["title"]),
								get = function() return sRaidFrames.opt.Layouts[i].title.offsetx or 0 end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].title.offsetx = tonumber(value); self:LayoutUpdate(i); end,
							},
							y = {
								name = "Y",
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s bar"], "Y "..L["offset"], L["title"]),
								get = function() return sRaidFrames.opt.Layouts[i].title.offsety or 0 end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].title.offsety = tonumber(value); self:LayoutUpdate(i); end,
							},
						},
					},
				},
			},
			hpbar = {
				name = L["HP bar"],
				type = "group",
				desc = string.format(L["Configure this layout's %s bar"], L["HP"]),
				args = {
					height = {
						name = L["Height"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["HP"]),
						get = function() return sRaidFrames.opt.Layouts[i].hpbar.height or 12 end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].hpbar.height = tonumber(value); self:LayoutUpdate(i); end,
					},
				},
			},
			mpbar = {
				name = L["Mana bar"],
				type = "group",
				desc = string.format(L["Configure this layout's %s bar"], L["Mana"]),
				args = {
					height = {
						name = L["Height"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["Mana"]),
						get = function() return sRaidFrames.opt.Layouts[i].mpbar.height or 4 end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].mpbar.height = tonumber(value); self:LayoutUpdate(i); end,
					},
				},
			},
			buffsdebuffs = {
				name = L["Buffs & Debuffs"],
				type = "group",
				desc = string.format(L["Configure this layout's %s"], L["Buffs & Debuffs"]),
				args = {
					anchor = {
						name = L["Anchor"],
						type = "select",
						desc = string.format(L["Configure the %s of this layout's %s"], L["anchor"], L["Buffs & Debuffs"]),
						get = function() return sRaidFrames.opt.Layouts[i].debuff.anchor or "TOPRIGHT" end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.anchor = tonumber(value); self:LayoutUpdate(i); end,
						values = {["TOPRIGHT"] = L["Top right"], ["TOPLEFT"] = L["Top left"], ["BOTTOMRIGHT"] = L["Bottom right"], ["BOTTOMLEFT"] = L["Bottom left"]},
					},
					buffs = {
						name = L["Buffs"],
						type = "group",
						desc = string.format(L["Configure this layout's %s"], L["Buffs"]),
						args = {
							width = {
								name = L["Width"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["width"], L["Buffs"]),
								get = function() return sRaidFrames.opt.Layouts[i].buff.width or 12 end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].buff.width = tonumber(value); self:LayoutUpdate(i); end,
							},
							height = {
								name = L["Height"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["height"], L["Buffs"]),
								get = function() return sRaidFrames.opt.Layouts[i].buff.height or 12 end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].buff.height = tonumber(value); self:LayoutUpdate(i); end,
							},
						},
					},
					debuffs = {
						name = L["Debuffs"],
						type = "group",
						desc = string.format(L["Configure this layout's %s"], L["Debuffs"]),
						args = {
							width = {
								name = L["Width"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["width"], L["Debuffs"]),
								get = function() return sRaidFrames.opt.Layouts[i].debuff.width or 16 end,
								set = function() sRaidFrames.opt.Layouts[i].debuff.width = value; self:LayoutUpdate(i); end,
							},
							height = {
								name = L["Height"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["height"], L["Debuffs"]),
								get = function() return sRaidFrames.opt.Layouts[i].debuff.height or 16 end,
								set = function() sRaidFrames.opt.Layouts[i].debuff.height = value; self:LayoutUpdate(i); end,
							},
						},
					},
				},
			},
			border = {
				name = L["Border"],
				type = "toggle",
				desc = L["Select whether this layout uses a border"],
				get = function() return sRaidFrames.opt.Layouts[i].border or false end,
				set = function(info, value) sRaidFrames.opt.Layouts[i].border = value; self:LayoutUpdate(i); end,
			},
		},
	}
end

function sRaidFrames:LayoutUpdate(i)
	local data = sRaidFrames.opt.Layouts[i]
	sRaidFrames.Layouts[data.intname] = {
		Name = data.name,
		HasBorders = data.border,
		StyleUnitFrame = function(f)
			sRaidFrames:SetWHP(f, data.border and data.title.width+10 or data.title.width, (data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height));
			sRaidFrames:SetWHP(f.title, data.title.width, data.title.height, "TOPLEFT", f, "TOPLEFT", data.border and data.title.offsetx+5 or data.title.offsetx, data.border and data.title.offsety-4 or data.title.offsety)
			sRaidFrames:SetWHP(f.aura1, data.debuff.width, data.debuff.height, data.debuff.anchor, f, data.debuff.anchor, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)
			sRaidFrames:SetWHP(f.aura2, data.debuff.width, data.debuff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.aura1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			if sRaidFrames.opt.BuffType == "both" then
				sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor=="TOPRIGHT" and "TOPLEFT" or data.debuff.anchor=="TOPLEFT" and "TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT" and "BOTTOMLEFT" or data.debuff.anchor=="BOTTOMLEFT" and "BOTTOMRIGHT", 0, 0)
			else
				sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)
			end
			sRaidFrames:SetWHP(f.buff2, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.buff3, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff2, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.buff4, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff3, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.hpbar, data.title.width, data.hpbar.height, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
			sRaidFrames:SetWHP(f.mpbar, data.title.width, data.mpbar.height, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
			sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
			sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
			f:SetBackdrop(data.border and { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
									tile = true,
									tileSize = 16,
									edgeFile = Media:Fetch("border", sRaidFrames.opt.BorderTexture),
									edgeSize = 16,
									insets = { left = 5, right = 5, top = 5, bottom = 5 }
								} or { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
			f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
			f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		end,
		unitframeWidth = data.border and data.title.width+10 or data.title.width,
		unitframeHeight = (data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height),
		headerWidth = data.border and data.title.width+10 or data.title.width,
		headerHeight = 15, -- needs more testing
		debuffCount = 2,
		buffCount = 4,
	}
	self.options.args.behaviour.args.layout.values = {}
	for _name, _data in pairs(self.Layouts) do
		self.options.args.behaviour.args.layout.values[_name] = _data.Name
	end
	if data.intname == sRaidFrames.opt.Layout then self:ApplyLayout() end
end

function sRaidFrames:SetLayout(name)
	if not self.Layouts[name] then
		return
	end
	self.opt.Layout = name
	self.CurrentLayout = self.Layouts[name]
end

function sRaidFrames:ApplyLayout()
	for _, f in ipairs(self.frames) do
		self:GetLayout().StyleUnitFrame(f)
	end
	for unit in pairs(self:GetAllUnits()) do
		self:UpdateStatuses(unit)
	end
	self:SetSpacing()
end

function sRaidFrames:GetLayout()
	if not self.CurrentLayout then
		self:SetLayout(self.opt.Layout)
	end
	return self.CurrentLayout
end

sRaidFrames:RegisterLayout("CTRA_WithBorders", {
	Name = L["CT_RaidAssist"],
	HasBorders = true,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 90, 40)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  5, -4)
		sRaidFrames:SetWHP(f.aura1, 16, 16, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		sRaidFrames:SetWHP(f.aura2, 16, 16, "RIGHT", f.aura1, "LEFT", 0, 0)
		if sRaidFrames.opt.BuffType == "both" then
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f.aura2,"TOPLEFT", 0, 0);
		else
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		end
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		
		f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
									tile = true,
									tileSize = 16,
									edgeFile = Media:Fetch("border", sRaidFrames.opt.BorderTexture),
									edgeSize = 16,
									insets = { left = 5, right = 5, top = 5, bottom = 5 }
								})
								
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f:SetBackdropBorderColor(sRaidFrames.opt.BorderColor.r, sRaidFrames.opt.BorderColor.g, sRaidFrames.opt.BorderColor.b, sRaidFrames.opt.BorderColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
	end,
	unitframeWidth = 90,
	unitframeHeight = 40,
	headerWidth = 90,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 4,
})

sRaidFrames:RegisterLayout("CTRA_NoBorders", {
	Name = L["CT_RaidAssist (Without Borders)"],
	HasBorders = false,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 80, 32)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  0, 0)
		sRaidFrames:SetWHP(f.aura1, 16, 16, "TOPRIGHT", f, "TOPRIGHT", 0, 0)
		sRaidFrames:SetWHP(f.aura2, 16, 16, "RIGHT", f.aura1, "LEFT", 0, 0)
		if sRaidFrames.opt.BuffType == "both" then
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f.aura2, "TOPLEFT", 0, 0);
		else
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", 0, 0)
		end
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
		
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
	end,
	unitframeWidth = 80,
	unitframeHeight = 32,
	headerWidth = 80,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 4,
})

sRaidFrames:RegisterLayout("CTRA_NoBordersWide", {
	Name = L["CT_RaidAssist (Without borders, Wide)"],
	HasBorders = false,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 90, 40)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  5, -4)
		sRaidFrames:SetWHP(f.aura1, 16, 16, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		sRaidFrames:SetWHP(f.aura2, 16, 16, "RIGHT", f.aura1, "LEFT", 0, 0)
		if sRaidFrames.opt.BuffType == "both" then
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f.aura2, "TOPLEFT", 0, 0);
		else
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		end
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		
		f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
								
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
	end,
	unitframeWidth = 90,
	unitframeHeight = 40,
	headerWidth = 90,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 4,
})
function sRaidFrames:RegisterCustomLayouts()
	for i=1, #sRaidFrames.opt.Layouts do
		local data = sRaidFrames.opt.Layouts[i];
		sRaidFrames:RegisterLayout(data.intname, {
			Name = data.name,
			HasBorders = data.border,
			StyleUnitFrame = function(f)
				sRaidFrames:SetWHP(f, data.border and data.title.width+10 or data.title.width, (data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height));
				sRaidFrames:SetWHP(f.title, data.title.width, data.title.height, "TOPLEFT", f, "TOPLEFT", data.border and data.title.offsetx+5 or data.title.offsetx, data.border and data.title.offsety-4 or data.title.offsety)
				sRaidFrames:SetWHP(f.aura1, data.debuff.width, data.debuff.height, data.debuff.anchor, f, data.debuff.anchor, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)
				sRaidFrames:SetWHP(f.aura2, data.debuff.width, data.debuff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.aura1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
				if sRaidFrames.opt.BuffType == "both" then
					sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor=="TOPRIGHT" and "TOPLEFT" or data.debuff.anchor=="TOPLEFT" and "TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT" and "BOTTOMLEFT" or data.debuff.anchor=="BOTTOMLEFT" and "BOTTOMRIGHT", 0, 0)
				else
					sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0, (data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)
				end
				sRaidFrames:SetWHP(f.buff2, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
				sRaidFrames:SetWHP(f.buff3, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff2, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
				sRaidFrames:SetWHP(f.buff4, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff3, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
				sRaidFrames:SetWHP(f.hpbar, data.title.width, data.hpbar.height, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
				sRaidFrames:SetWHP(f.mpbar, data.title.width, data.mpbar.height, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
				sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
				sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
				f:SetBackdrop(data.border and { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true,
										tileSize = 16,
										edgeFile = Media:Fetch("border", sRaidFrames.opt.BorderTexture),
										edgeSize = 16,
										insets = { left = 5, right = 5, top = 5, bottom = 5 }
									} or { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
											tile = true, tileSize = 16,
											insets = { left = 0, right = 0, top = 0, bottom = 0 }
										})
				f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
				f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
			end,
			unitframeWidth = data.border and data.title.width+10 or data.title.width,
			unitframeHeight = (data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height),
			headerWidth = data.border and data.title.width+10 or data.title.width,
			headerHeight = 15, -- needs more testing
			debuffCount = 2,
			buffCount = 4,
		})
		self.options.args.layouts.args[data.intname] = {
			name = data.name,
			type = "group",
			desc = L["Configure "]..data.name,
			args = {
				titlebar = {
					name = L["Title bar"],
					type = "group",
					desc = string.format(L["Configure this layout's %s bar"], L["title"]),
					args = {
						height = {
							name = L["Height"],
							type = "input",
							desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["title"]).."\n"..L["Default:"].." 16",
							get = function() return self.opt.Layouts[i].title.height or 16 end,
							set = function(info, value) self.opt.Layouts[i].title.height = tonumber(value); self:LayoutUpdate(i); end,
							order=1,
						},
						width = {
							name = L["Width"],
							type = "input",
							desc = string.format(L["Modify the %s of this layout's %s bar"], L["width"], L["title"]).."\n"..L["Default:"].." 16",
							get = function() return self.opt.Layouts[i].title.width or 80 end,
							set = function(info, value) self.opt.Layouts[i].title.width = tonumber(value); self:LayoutUpdate(i); end,
							order=2,
						},
						offsets = {
							name = L["Offsets"],
							type = "group",
							desc = string.format(L["Modify the %s of this layout's %s bar"], L["offsets"], L["title"]),
							args = {
								x = {
									name = "X",
									type = "input",
									desc = string.format(L["Modify the %s of this layout's %s bar"], "X "..L["offset"], L["title"]).."\n"..L["Default:"].." 0",
									get = function() return sRaidFrames.opt.Layouts[i].title.offsetx or 0 end,
									set = function(info, value) sRaidFrames.opt.Layouts[i].title.offsetx = tonumber(value); self:LayoutUpdate(i); end,
								},
								y = {
									name = "Y",
									type = "input",
									desc = string.format(L["Modify the %s of this layout's %s bar"], "Y "..L["offset"], L["title"]).."\n"..L["Default:"].." 0",
									get = function() return sRaidFrames.opt.Layouts[i].title.offsety or 0 end,
									set = function(info, value) sRaidFrames.opt.Layouts[i].title.offsety = tonumber(value); self:LayoutUpdate(i); end,
								},
							},
							dialogInline = true,
							order=3,
						},
					},
				},
				hpbar = {
					name = L["HP bar"],
					type = "group",
					desc = string.format(L["Configure this layout's %s bar"], L["HP"]),
					args = {
						height = {
							name = L["Height"],
							type = "input",
							desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["HP"]).."\n"..L["Default:"].." 12",
							get = function() return sRaidFrames.opt.Layouts[i].hpbar.height or 12 end,
							set = function(info, value) sRaidFrames.opt.Layouts[i].hpbar.height = tonumber(value); self:LayoutUpdate(i); end,
						},
					},
				},
				mpbar = {
					name = L["Mana bar"],
					type = "group",
					desc = string.format(L["Configure this layout's %s bar"], L["Mana"]),
					args = {
						height = {
							name = L["Height"],
							type = "input",
							desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["Mana"]).."\n"..L["Default:"].." 4",
							get = function() return sRaidFrames.opt.Layouts[i].mpbar.height or 4 end,
							set = function(info, value) sRaidFrames.opt.Layouts[i].mpbar.height = tonumber(value); self:LayoutUpdate(i); end,
						},
					},
				},
				buffsdebuffs = {
					name = L["Buffs & Debuffs"],
					type = "group",
					desc = string.format(L["Configure this layout's %s"], L["Buffs & Debuffs"]),
					args = {
						anchor = {
							name = L["Anchor"],
							type = "select",
							desc = string.format(L["Configure the %s of this layout's %s"], L["anchor"], L["Buffs & Debuffs"]).."\n"..L["Default:"].." "..L["Top right"],
							get = function() return sRaidFrames.opt.Layouts[i].debuff.anchor or "TOPRIGHT" end,
							set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.anchor = value; self:LayoutUpdate(i); end,
							values = {["TOPRIGHT"] = L["Top right"], ["TOPLEFT"] = L["Top left"], ["BOTTOMRIGHT"] = L["Bottom right"], ["BOTTOMLEFT"] = L["Bottom left"]},
						},
						buffs = {
							name = L["Buffs"],
							type = "group",
							desc = string.format(L["Configure this layout's %s"], L["Buffs"]),
							args = {
								width = {
									name = L["Width"],
									type = "input",
									desc = string.format(L["Modify the %s of this layout's %s"], L["width"], L["Buffs"]).."\n"..L["Default:"].." 12",
									get = function() return sRaidFrames.opt.Layouts[i].buff.width or 12 end,
									set = function(info, value) sRaidFrames.opt.Layouts[i].buff.width = tonumber(value); self:LayoutUpdate(i); end,
								},
								height = {
									name = L["Height"],
									type = "input",
									desc = string.format(L["Modify the %s of this layout's %s"], L["height"], L["Buffs"]).."\n"..L["Default:"].." 12",
									get = function() return sRaidFrames.opt.Layouts[i].buff.height or 12 end,
									set = function(info, value) sRaidFrames.opt.Layouts[i].buff.height = tonumber(value); self:LayoutUpdate(i); end,
								},
							},
						},
						debuffs = {
							name = L["Debuffs"],
							type = "group",
							desc = string.format(L["Configure this layout's %s"], L["Debuffs"]),
							args = {
								width = {
									name = L["Width"],
									type = "input",
									desc = string.format(L["Modify the %s of this layout's %s"], L["width"], L["Debuffs"]).."\n"..L["Default:"].." 16",
									get = function() return sRaidFrames.opt.Layouts[i].debuff.width or 16 end,
									set = function() sRaidFrames.opt.Layouts[i].debuff.width = value; self:LayoutUpdate(i); end,
								},
								height = {
									name = L["Height"],
									type = "input",
									desc = string.format(L["Modify the %s of this layout's %s"], L["height"], L["Debuffs"]).."\n"..L["Default:"].." 16",
									get = function() return sRaidFrames.opt.Layouts[i].debuff.height or 16 end,
									set = function() sRaidFrames.opt.Layouts[i].debuff.height = value; self:LayoutUpdate(i); end,
								},
							},
						},
					},
				},
				border = {
					name = L["Border"],
					type = "toggle",
					desc = L["Select whether this layout uses a border"].."\n"..L["Default:"].." "..L["No"],
					get = function() return sRaidFrames.opt.Layouts[i].border or false end,
					set = function(info, value) sRaidFrames.opt.Layouts[i].border = value; self:LayoutUpdate(i); end,
				},
			},
		}
	end
end
--[[
sRaidFrames:RegisterLayout("sRaidFrames", {
	Name = "sRaidFrames",
	HasBorders = true,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 80, 30)
		sRaidFrames:SetWHP(f.title, 78, 13, "TOPLEFT", f, "TOPLEFT",  1, 0)
		sRaidFrames:SetWHP(f.aura1, 13, 13, "TOPRIGHT", f, "TOPRIGHT", -1, -1)
		sRaidFrames:SetWHP(f.aura2, 13, 13, "RIGHT", f.aura1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff1, 13, 13, "TOPRIGHT", f, "TOPRIGHT", -1, -1)
		sRaidFrames:SetWHP(f.buff2, 13, 13, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 13, 13, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 78, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 78, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		
		f:SetBackdrop({ bgFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder",
									tile = true,
									tileSize = 16,
									edgeFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder",
									edgeSize = 1,
									insets = { left = 1, right = 1, top = 1, bottom = 1 }
								})
								
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f:SetBackdropBorderColor(sRaidFrames.opt.BorderColor.r, sRaidFrames.opt.BorderColor.g, sRaidFrames.opt.BorderColor.b, sRaidFrames.opt.BorderColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
	end,
	unitframeWidth = 80,
	unitframeHeight = 30,
	headerWidth = 85,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 3,
})



sRaidFrames:RegisterLayout("Grid", {
	Name = "Dispell Grid",
	HasBorders = false,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 26, 26)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  5, -4)
		
		sRaidFrames:SetWHP(f.aura1, 16, 16, "CENTER", f, "CENTER", 0, 0)
		
		sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f, "TOPLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPRIGHT", f, "TOPRIGHT", 0, 0)
		
		f.hpbar:Hide()
		f.mpbar:Hide()
	
		sRaidFrames:SetWHP(f.title, f:GetWidth()-4, f.hpbar:GetHeight(), "CENTER", f, "CENTER", 0, 0)
		
		f.title:SetJustifyH("CENTER")
		f.title:SetNonSpaceWrap(true)
		
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f:SetBackdropBorderColor(sRaidFrames.opt.BorderColor.r, sRaidFrames.opt.BorderColor.g, sRaidFrames.opt.BorderColor.b, sRaidFrames.opt.BorderColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		
		f:SetBackdrop( {
				      bgFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder", tile = true, tileSize = 16,
				      edgeFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder", edgeSize = 1,
				      insets = {left = 1, right = 1, top = 1, bottom = 1},
			      })
	end,
	unitframeWidth = 26,
	unitframeHeight = 26,
	headerWidth = 26,
	headerHeight = 15,
	debuffCount = 1,
	buffCount = 4,
})
]]--